> For the complete documentation index, see [llms.txt](https://docs.postgresql.tw/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.postgresql.tw/15/reference/sql-commands/end.md).

# END

## END

END — commit the current transaction

### Synopsis

```

END [ WORK | TRANSACTION ] [ AND [ NO ] CHAIN ]
```

### Description

`END` commits the current transaction. All changes made by the transaction become visible to others and are guaranteed to be durable if a crash occurs. This command is a PostgreSQL extension that is equivalent to [`COMMIT`](/15/reference/sql-commands/commit.md).

### Parameters

`WORK`\
`TRANSACTION`

Optional key words. They have no effect.

`AND CHAIN`

If `AND CHAIN` is specified, a new transaction is immediately started with the same transaction characteristics (see [SET TRANSACTION](/15/reference/sql-commands/set-transaction.md)) as the just finished one. Otherwise, no new transaction is started.

### Notes

Use [`ROLLBACK`](/15/reference/sql-commands/rollback.md) to abort a transaction.

Issuing `END` when not inside a transaction does no harm, but it will provoke a warning message.

### Examples

To commit the current transaction and make all changes permanent:

```

END;
```

### Compatibility

`END` is a PostgreSQL extension that provides functionality equivalent to [`COMMIT`](/15/reference/sql-commands/commit.md), which is specified in the SQL standard.

### See Also

[BEGIN](/15/reference/sql-commands/begin.md), [COMMIT](/15/reference/sql-commands/commit.md), [ROLLBACK](/15/reference/sql-commands/rollback.md)

***

原文：[PostgreSQL 15.19 Documentation](/15/reference/sql-commands/end.md)（英文原文，待翻譯）


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.postgresql.tw/15/reference/sql-commands/end.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
